﻿using System.Linq;
using System.Net;
using RGiesecke.DllExport;
using System.Net.Mail;

namespace EmailSender
{
    public class EmailSender
    {
        [DllExport]
        public static void SendReceipt(string name, string email, string releases)
        {
            MailAddress fromAddress = new MailAddress("receipt.vinylscratch@gmail.com", "Vinyl Scratch");
            MailAddress toAddress = new MailAddress(email, name);
            const string fromPassword = "ThisIsNotARealPassword";

            var smtp = new SmtpClient
                           {
                               Host = "smtp.gmail.com",
                               Port = 587,
                               EnableSsl = true,
                               DeliveryMethod = SmtpDeliveryMethod.Network,
                               UseDefaultCredentials = false,
                               Credentials = new NetworkCredential(fromAddress.Address, fromPassword)
                           };

            string[] releasesArray = releases.Split('|');
            var releasesList = releasesArray.Select(release => release.Split(';')).ToList();

            string msg = "<html>\n";
            msg += "<body>\n";
            msg += string.Format("Tisztelt {0}!\n", name);
            msg += "Köszönjük, hogy a VinylScratch boltban vásárolt!<br/>\n";
            msg += "<br/>\n";
            msg += "A vásárolt termékei:<br/>\n";
            msg += "<br/>\n";
            msg += "<table border=1>\n";
            msg +=
                "<th><td>Előadó</td><td>Cím</td><td>Kiadványszám</td><td>Formátum</td><td>Ár</td></th>\n";

            float sum = 0;

            for (int i = 0; i < releasesList.Count; i++)
            {
                string[] release = releasesList[i];
                msg +=
                    string.Format(
                        "<tr><td>{0:2}.</td><td>{1}</td><td>{2}</td><td>{3}</td><td>{4}</td><td>{5}</td></tr>\n",
                        i, release[0], release[1], release[2], release[3], release[4]);
                sum += float.Parse(release[4]);
            }

            msg +=
                string.Format(
                    "<tr><i><td>Összesen:</td><td></td><td></td><td></td><td></td><td></td>{0}</i></tr>\n", sum);
            msg += "</table>\n";
            msg += "<br/>\n";
            msg += "<i>Üdvözlettel:<br/>";
            msg += "VinylScratch<br/>\n";
            msg += "<a href=mailto:info@vinylscratch.hu>info@vinylscratch.hu</a></i><br/>\n";
            msg += "</body>\n";
            msg += "</html>\n";

            using (var message = new MailMessage(fromAddress, toAddress)
                                     {
                                         Subject =
                                             "Vinyl Scratch - Sikeres Vásárlás (" + releasesArray.Length + " tétel)",
                                         Body = msg
                                     })
            {
                smtp.Send(message);
            }
        }
    }
}