CREATE TABLE albumok (
    eloado VARCHAR(255) NOT NULL,
    cim VARCHAR(255) NOT NULL,
    mufaj VARCHAR(255)
);
ALTER TABLE albumok ADD CONSTRAINT pk_albumok PRIMARY KEY (eloado, cim);

CREATE TABLE kiadvanyok (
	eloado VARCHAR(255) NOT NULL,
	cim VARCHAR(255) NOT NULL,
	kiadvanyszam VARCHAR(255) NOT NULL,
	kiado VARCHAR(255),
	formatum VARCHAR(255),
	kiadas_eve NUMBER,
	ar NUMBER
);
ALTER TABLE kiadvanyok ADD CONSTRAINT pk_kiadvanyok PRIMARY KEY (eloado, cim, kiadvanyszam);
ALTER TABLE kiadvanyok ADD CONSTRAINT fk_kiadvanyok FOREIGN KEY (eloado, cim) REFERENCES albumok(eloado, cim) ON DELETE CASCADE;

CREATE TABLE vasarlok (
	nev VARCHAR(255) NOT NULL,
	cim VARCHAR(255) NOT NULL,
	telefonszam VARCHAR(255),
	email VARCHAR(255)
);
ALTER TABLE vasarlok ADD CONSTRAINT pk_vasarlok PRIMARY KEY (nev, cim);

CREATE TABLE szamlak (
	szamlaszam VARCHAR(255) NOT NULL,
	vasarlo_neve VARCHAR(255) NOT NULL,
	vasarlo_cime VARCHAR (255) NOT NULL
);
ALTER TABLE szamlak ADD CONSTRAINT pk_szamlak PRIMARY KEY (szamlaszam);
ALTER TABLE szamlak ADD CONSTRAINT fk_szamlak FOREIGN KEY (vasarlo_neve, vasarlo_cime) REFERENCES vasarlok(nev, cim) ON DELETE CASCADE;

CREATE TABLE eladasok (
	szamlaszam VARCHAR(255) NOT NULL,
	eloado VARCHAR(255) NOT NULL,
	cim VARCHAR(255) NOT NULL,
	kiadvanyszam VARCHAR(255) NOT NULL,
	idopont TIMESTAMP
);
ALTER TABLE eladasok ADD CONSTRAINT pk_eladasok PRIMARY KEY (szamlaszam, eloado, cim, kiadvanyszam);
ALTER TABLE eladasok ADD CONSTRAINT fk_eladasok_szamla FOREIGN KEY (szamlaszam) REFERENCES szamlak(szamlaszam) ON DELETE CASCADE;
ALTER TABLE eladasok ADD CONSTRAINT fk_eladasok_album FOREIGN KEY (eloado, cim, kiadvanyszam) REFERENCES kiadvanyok(eloado, cim, kiadvanyszam) ON DELETE CASCADE;

CREATE GLOBAL TEMPORARY TABLE eladasok_temp 
ON COMMIT PRESERVE ROWS 
AS SELECT * FROM eladasok;
